diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/test/wifi-phy-ofdma-test.cc ns-3.43/src/wifi/test/wifi-phy-ofdma-test.cc
--- ns-3.42/src/wifi/test/wifi-phy-ofdma-test.cc	2024-05-29 15:29:47.220074000 -0700
+++ ns-3.43/src/wifi/test/wifi-phy-ofdma-test.cc	2024-10-09 16:41:10.140657000 -0700
@@ -3053,20 +3047,20 @@
      * Check the received power for the non-OFDMA of the HE TB PPDUs over the given band
      * \param phy the PHY
      * \param band the indices of the band over which the power is measured
-     * \param expectedRxPower the expected received power in W
+     * \param expectedRxPower the expected received power
      */
     void CheckNonOfdmaRxPower(Ptr<OfdmaSpectrumWifiPhy> phy,
                               WifiSpectrumBandInfo band,
-                              double expectedRxPower);
+                              Watt_u expectedRxPower);
     /**
      * Check the received power for the OFDMA part of the HE TB PPDUs over the given band
      * \param phy the PHY
      * \param band the indices of the band over which the power is measured
-     * \param expectedRxPower the expected received power in W
+     * \param expectedRxPower the expected received power
      */
     void CheckOfdmaRxPower(Ptr<OfdmaSpectrumWifiPhy> phy,
                            WifiSpectrumBandInfo band,
-                           double expectedRxPower);
+                           Watt_u expectedRxPower);
 
     /**
      * Verify all events are cleared at end of TX or RX
@@ -3161,16 +3155,16 @@
      * Schedule power measurement related checks.
      *
      * \param delay the reference delay used to schedule the events
-     * \param rxPowerNonOfdmaRu1 the received power (in watts) on the non-OFDMA part of RU1
-     * \param rxPowerNonOfdmaRu2 the received power (in watts) on the non-OFDMA part of RU2
-     * \param rxPowerOfdmaRu1 the received power (in watts) on RU1
-     * \param rxPowerOfdmaRu2 the received power (in watts) on RU2
+     * \param rxPowerNonOfdmaRu1 the received power on the non-OFDMA part of RU1
+     * \param rxPowerNonOfdmaRu2 the received power on the non-OFDMA part of RU2
+     * \param rxPowerOfdmaRu1 the received power on RU1
+     * \param rxPowerOfdmaRu2 the received power on RU2
      */
     void SchedulePowerMeasurementChecks(Time delay,
-                                        double rxPowerNonOfdmaRu1,
-                                        double rxPowerNonOfdmaRu2,
-                                        double rxPowerOfdmaRu1,
-                                        double rxPowerOfdmaRu2);
+                                        Watt_u rxPowerNonOfdmaRu1,
+                                        Watt_u rxPowerNonOfdmaRu2,
+                                        Watt_u rxPowerOfdmaRu1,
+                                        Watt_u rxPowerOfdmaRu2);
     /**
      * Log scenario description
      *
@@ -3195,8 +3189,8 @@
     uint32_t m_countRxBytesFromSta1;   ///< count RX bytes from STA 1
     uint32_t m_countRxBytesFromSta2;   ///< count RX bytes from STA 2
 
-    uint16_t m_frequency;        ///< frequency in MHz
-    uint16_t m_channelWidth;     ///< channel width in MHz
+    MHz_u m_frequency;           ///< frequency
+    MHz_u m_channelWidth;        ///< channel width
     Time m_expectedPpduDuration; ///< expected duration to send MU PPDU
 };
 
@@ -3223,20 +3217,20 @@
     NS_LOG_FUNCTION(this << txStaId << payloadSize << uid << +bssColor);
     WifiConstPsduMap psdus;
 
-    WifiTxVector txVector = WifiTxVector(HePhy::GetHeMcs7(),
-                                         0,
-                                         WIFI_PREAMBLE_HE_SU,
-                                         800,
-                                         1,
-                                         1,
-                                         0,
-                                         m_channelWidth,
-                                         false,
-                                         false,
-                                         false,
-                                         bssColor);
+    WifiTxVector txVector{HePhy::GetHeMcs7(),
+                          0,
+                          WIFI_PREAMBLE_HE_SU,
+                          NanoSeconds(800),
+                          1,
+                          1,
+                          0,
+                          m_channelWidth,
+                          false,
+                          false,
+                          false,
+                          bssColor};
 
-    Ptr<Packet> pkt = Create<Packet>(payloadSize);
+    auto pkt = Create<Packet>(payloadSize);
     WifiMacHeader hdr;
     hdr.SetType(WIFI_MAC_QOSDATA);
     hdr.SetQosTid(0);
@@ -3245,7 +3239,7 @@
     addr << "00:00:00:00:00:0" << txStaId;
     hdr.SetAddr2(Mac48Address(addr.str().c_str()));
     hdr.SetSequenceNumber(1);
-    Ptr<WifiPsdu> psdu = Create<WifiPsdu>(pkt, hdr);
+    auto psdu = Create<WifiPsdu>(pkt, hdr);
     psdus.insert(std::make_pair(SU_STA_ID, psdu));
 
     Ptr<OfdmaSpectrumWifiPhy> phy;
@@ -3274,20 +3268,20 @@
                                                    std::size_t index,
                                                    uint8_t bssColor) const
 {
-    WifiTxVector txVector = WifiTxVector(HePhy::GetHeMcs7(),
-                                         0,
-                                         WIFI_PREAMBLE_HE_TB,
-                                         1600,
-                                         1,
-                                         1,
-                                         0,
-                                         m_channelWidth,
-                                         false,
-                                         false,
-                                         false,
-                                         bssColor);
+    WifiTxVector txVector{HePhy::GetHeMcs7(),
+                          0,
+                          WIFI_PREAMBLE_HE_TB,
+                          NanoSeconds(1600),
+                          1,
+                          1,
+                          0,
+                          m_channelWidth,
+                          false,
+                          false,
+                          false,
+                          bssColor};
 
-    HeRu::RuType ruType = HeRu::RU_106_TONE;
+    auto ruType = HeRu::RU_106_TONE;
     if (m_channelWidth == 20)
     {
         ruType = HeRu::RU_106_TONE;
@@ -3309,7 +3303,7 @@
         NS_ASSERT_MSG(false, "Unsupported channel width");
     }
 
-    bool primary80MHz = true;
+    auto primary80MHz = true;
     if (m_channelWidth == 160 && index == 2)
     {
         primary80MHz = false;
@@ -3325,7 +3319,7 @@
 void
 TestUlOfdmaPhyTransmission::SetTrigVector(uint8_t bssColor, TrigVectorInfo error)
 {
-    uint16_t channelWidth = m_channelWidth;
+    auto channelWidth = m_channelWidth;
     if (error == CHANNEL_WIDTH)
     {
         channelWidth = (channelWidth == 160 ? 20 : channelWidth * 2);
@@ -3334,7 +3328,7 @@
     WifiTxVector txVector(HePhy::GetHeMcs7(),
                           0,
                           WIFI_PREAMBLE_HE_TB,
-                          1600,
+                          NanoSeconds(1600),
                           1,
                           1,
                           0,
@@ -3535,11 +3529,11 @@
 void
 TestUlOfdmaPhyTransmission::CheckNonOfdmaRxPower(Ptr<OfdmaSpectrumWifiPhy> phy,
                                                  WifiSpectrumBandInfo band,
-                                                 double expectedRxPower)
+                                                 Watt_u expectedRxPower)
 {
-    Ptr<Event> event = phy->GetCurrentEvent();
+    auto event = phy->GetCurrentEvent();
     NS_ASSERT(event);
-    auto rxPower = event->GetRxPowerW(band);
+    auto rxPower = event->GetRxPower(band);
     NS_LOG_FUNCTION(this << band << expectedRxPower << rxPower);
     // Since there is out of band emission due to spectrum mask, the tolerance cannot be very low
     NS_TEST_ASSERT_MSG_EQ_TOL(rxPower,
@@ -3553,7 +3547,7 @@
 void
 TestUlOfdmaPhyTransmission::CheckOfdmaRxPower(Ptr<OfdmaSpectrumWifiPhy> phy,
                                               WifiSpectrumBandInfo band,
-                                              double expectedRxPower)
+                                              Watt_u expectedRxPower)
 {
     /**
      * The current event cannot be used since it points to the preamble part of the HE TB PPDU.
@@ -3691,7 +3685,7 @@
 }
 
 void
-TestUlOfdmaPhyTransmission::SetPsdLimit(Ptr<WifiPhy> phy, double psdLimit)
+TestUlOfdmaPhyTransmission::SetPsdLimit(Ptr<WifiPhy> phy, dBm_per_MHz_u psdLimit)
 {
     NS_LOG_FUNCTION(this << phy << psdLimit);
     phy->SetAttribute("PowerDensityLimit", DoubleValue(psdLimit));
@@ -3975,22 +3969,22 @@
 
 void
 TestUlOfdmaPhyTransmission::SchedulePowerMeasurementChecks(Time delay,
-                                                           double rxPowerNonOfdmaRu1,
-                                                           double rxPowerNonOfdmaRu2,
-                                                           double rxPowerOfdmaRu1,
-                                                           double rxPowerOfdmaRu2)
-{
-    Time detectionDuration = WifiPhy::GetPreambleDetectionDuration();
-    WifiTxVector txVectorSta1 = GetTxVectorForHeTbPpdu(1, 1, 0);
-    WifiTxVector txVectorSta2 = GetTxVectorForHeTbPpdu(2, 2, 0);
-    Ptr<const HePhy> hePhy = m_phyAp->GetHePhy();
-    Time nonOfdmaDuration = hePhy->CalculateNonHeDurationForHeTb(txVectorSta2);
+                                                           Watt_u rxPowerNonOfdmaRu1,
+                                                           Watt_u rxPowerNonOfdmaRu2,
+                                                           Watt_u rxPowerOfdmaRu1,
+                                                           Watt_u rxPowerOfdmaRu2)
+{
+    const auto detectionDuration = WifiPhy::GetPreambleDetectionDuration();
+    const auto txVectorSta1 = GetTxVectorForHeTbPpdu(1, 1, 0);
+    const auto txVectorSta2 = GetTxVectorForHeTbPpdu(2, 2, 0);
+    const auto hePhy = m_phyAp->GetHePhy();
+    const auto nonOfdmaDuration = hePhy->CalculateNonHeDurationForHeTb(txVectorSta2);
     NS_ASSERT(nonOfdmaDuration == hePhy->CalculateNonHeDurationForHeTb(txVectorSta1));
 
-    std::vector<double> rxPowerNonOfdma{rxPowerNonOfdmaRu1, rxPowerNonOfdmaRu2};
+    std::vector<Watt_u> rxPowerNonOfdma{rxPowerNonOfdmaRu1, rxPowerNonOfdmaRu2};
     std::vector<WifiSpectrumBandInfo> nonOfdmaBand{hePhy->GetNonOfdmaBand(txVectorSta1, 1),
                                                    hePhy->GetNonOfdmaBand(txVectorSta2, 2)};
-    std::vector<double> rxPowerOfdma{rxPowerOfdmaRu1, rxPowerOfdmaRu2};
+    std::vector<Watt_u> rxPowerOfdma{rxPowerOfdmaRu1, rxPowerOfdmaRu2};
     std::vector<WifiSpectrumBandInfo> ofdmaBand{hePhy->GetRuBandForRx(txVectorSta1, 1),
                                                 hePhy->GetRuBandForRx(txVectorSta2, 2)};
 
@@ -4074,7 +4068,7 @@
          * power received from other transmitting STA (STA 1).
          * Cannot use CheckNonOfdmaRxPower method since current event not set.
          */
-        double rxPowerNonOfdmaSta1Only =
+        const auto rxPowerNonOfdmaSta1Only =
             (m_channelWidth >= 40)
                 ? rxPowerNonOfdma[0]
                 : rxPowerNonOfdma[0] / 2; // both STAs transmit over the same 20 MHz channel
@@ -4122,11 +4116,12 @@
     m_phySta2->AssignStreams(streamNumber);
     m_phySta3->AssignStreams(streamNumber);
 
-    auto channelNum = std::get<0>(*WifiPhyOperatingChannel::FindFirst(0,
-                                                                      m_frequency,
-                                                                      m_channelWidth,
-                                                                      WIFI_STANDARD_80211ax,
-                                                                      WIFI_PHY_BAND_5GHZ));
+    auto channelNum = WifiPhyOperatingChannel::FindFirst(0,
+                                                         m_frequency,
+                                                         m_channelWidth,
+                                                         WIFI_STANDARD_80211ax,
+                                                         WIFI_PHY_BAND_5GHZ)
+                          ->number;
 
     m_phyAp->SetOperatingChannel(
         WifiPhy::ChannelTuple{channelNum, m_channelWidth, WIFI_PHY_BAND_5GHZ, 0});
@@ -4288,7 +4283,7 @@
 
     Ptr<SpectrumModel> SpectrumInterferenceRu1 = Create<SpectrumModel>(bands);
     Ptr<SpectrumValue> interferencePsdRu1 = Create<SpectrumValue>(SpectrumInterferenceRu1);
-    double interferencePower = 0.1; // watts
+    Watt_u interferencePower{0.1};
     *interferencePsdRu1 = interferencePower / ((m_channelWidth / 2) * 20e6);
 
     Simulator::Schedule(delay + MicroSeconds(50),
@@ -4554,7 +4549,7 @@
                         &TestUlOfdmaPhyTransmission::LogScenario,
                         this,
                         "Measure power for reception of HE TB PPDU only on RU 2");
-    double rxPower =
+    auto rxPower =
         DbmToW(19); // 16+1 dBm at STAs and +2 at AP (no loss since all devices are colocated)
     SchedulePowerMeasurementChecks(delay,
                                    (m_channelWidth >= 40) ? 0.0 : rxPower,
@@ -4595,7 +4590,7 @@
                   ? DbmToW(19)
                   : DbmToW(18.0103); // 15.0103+1 dBm at STA 2 and +2 at AP for non-OFDMA
                                      // transmitted only on one 20 MHz channel
-    double rxPowerOfdma = rxPower;
+    auto rxPowerOfdma = rxPower;
     if (m_channelWidth <= 40)
     {
         rxPowerOfdma = (m_channelWidth == 20)
@@ -4635,9 +4630,9 @@
                         this,
                         "Measure power for reception of HE TB PPDU on both RUs");
     rxPower = DbmToW(19); // 16+1 dBm at STAs and +2 at AP (no loss since all devices are colocated)
-    double rxPowerNonOfdma = (m_channelWidth >= 40)
-                                 ? rxPower
-                                 : rxPower * 2; // both STAs transmit over the same 20 MHz channel
+    const auto rxPowerNonOfdma =
+        (m_channelWidth >= 40) ? rxPower
+                               : rxPower * 2; // both STAs transmit over the same 20 MHz channel
     SchedulePowerMeasurementChecks(delay, rxPowerNonOfdma, rxPowerNonOfdma, rxPower, rxPower);
     ScheduleTest(delay,
                  true,
@@ -4883,24 +4878,24 @@
 {
     WifiConstPsduMap psdus;
 
-    WifiTxVector txVector = WifiTxVector(HePhy::GetHeMcs7(),
-                                         0,
-                                         WIFI_PREAMBLE_HE_TB,
-                                         1600,
-                                         1,
-                                         1,
-                                         0,
-                                         DEFAULT_CHANNEL_WIDTH,
-                                         false,
-                                         false,
-                                         true);
+    WifiTxVector txVector{HePhy::GetHeMcs7(),
+                          0,
+                          WIFI_PREAMBLE_HE_TB,
+                          NanoSeconds(1600),
+                          1,
+                          1,
+                          0,
+                          DEFAULT_CHANNEL_WIDTH,
+                          false,
+                          false,
+                          true};
 
     HeRu::RuSpec ru(HeRu::RU_106_TONE, index, false);
     txVector.SetRu(ru, txStaId);
     txVector.SetMode(HePhy::GetHeMcs7(), txStaId);
     txVector.SetNss(1, txStaId);
 
-    Ptr<Packet> pkt = Create<Packet>(payloadSize);
+    auto pkt = Create<Packet>(payloadSize);
     WifiMacHeader hdr;
     hdr.SetType(WIFI_MAC_QOSDATA);
     hdr.SetQosTid(0);
@@ -4909,7 +4904,7 @@
     addr << "00:00:00:00:00:0" << txStaId;
     hdr.SetAddr2(Mac48Address(addr.str().c_str()));
     hdr.SetSequenceNumber(1);
-    Ptr<WifiPsdu> psdu = Create<WifiPsdu>(pkt, hdr);
+    auto psdu = Create<WifiPsdu>(pkt, hdr);
     psdus.insert(std::make_pair(txStaId, psdu));
 
     Ptr<OfdmaSpectrumWifiPhy> phy;
@@ -5095,11 +5090,12 @@
     m_phyAp->AddChannel(spectrumChannel);
     m_phyAp->ConfigureStandard(WIFI_STANDARD_80211ax);
     m_phyAp->AssignStreams(streamNumber);
-    auto channelNum = std::get<0>(*WifiPhyOperatingChannel::FindFirst(0,
-                                                                      DEFAULT_FREQUENCY,
-                                                                      DEFAULT_CHANNEL_WIDTH,
-                                                                      WIFI_STANDARD_80211ax,
-                                                                      WIFI_PHY_BAND_5GHZ));
+    auto channelNum = WifiPhyOperatingChannel::FindFirst(0,
+                                                         DEFAULT_FREQUENCY,
+                                                         DEFAULT_CHANNEL_WIDTH,
+                                                         WIFI_STANDARD_80211ax,
+                                                         WIFI_PHY_BAND_5GHZ)
+                          ->number;
 
     m_phyAp->SetOperatingChannel(
         WifiPhy::ChannelTuple{channelNum, DEFAULT_CHANNEL_WIDTH, WIFI_PHY_BAND_5GHZ, 0});
@@ -5181,17 +5177,17 @@
 void
 TestPhyPaddingExclusion::SetTrigVector(Time ppduDuration)
 {
-    WifiTxVector trigVector(HePhy::GetHeMcs7(),
+    WifiTxVector trigVector{HePhy::GetHeMcs7(),
                             0,
                             WIFI_PREAMBLE_HE_TB,
-                            1600,
+                            NanoSeconds(1600),
                             1,
                             1,
                             0,
                             DEFAULT_CHANNEL_WIDTH,
                             false,
                             false,
-                            true);
+                            true};
     trigVector.SetRu(HeRu::RuSpec(HeRu::RU_106_TONE, 1, false), 1);
     trigVector.SetMode(HePhy::GetHeMcs7(), 1);
     trigVector.SetNss(1, 1);
@@ -5290,7 +5286,7 @@
 
     Ptr<SpectrumModel> SpectrumInterferenceRu1 = Create<SpectrumModel>(bands);
     Ptr<SpectrumValue> interferencePsdRu1 = Create<SpectrumValue>(SpectrumInterferenceRu1);
-    double interferencePower = 0.1; // watts
+    Watt_u interferencePower{0.1};
     *interferencePsdRu1 = interferencePower / ((DEFAULT_CHANNEL_WIDTH / 2) * 20e6);
 
     Simulator::Schedule(Seconds(2.0) + MicroSeconds(50) + expectedPpduDuration,
@@ -5395,18 +5391,18 @@
 
     Ptr<SpectrumWifiPhy> m_phyAp; ///< PHY of AP
 
-    double m_txPowerAp;      ///< transmit power (in dBm) of AP
-    double m_txPowerStart;   ///< minimum transmission power (in dBm) for STAs
-    double m_txPowerEnd;     ///< maximum transmission power (in dBm) for STAs
+    dBm_u m_txPowerAp;       ///< transmit power of AP
+    dBm_u m_txPowerStart;    ///< minimum transmission power for STAs
+    dBm_u m_txPowerEnd;      ///< maximum transmission power for STAs
     uint8_t m_txPowerLevels; ///< number of transmission power levels for STAs
 
-    double m_requestedRssiSta1; ///< requested RSSI (in dBm) from STA 1 at AP for HE TB PPDUs
-    double m_requestedRssiSta2; ///< requested RSSI (in dBm) from STA 2 at AP for HE TB PPDUs
+    dBm_u m_requestedRssiSta1; ///< requested RSSI from STA 1 at AP for HE TB PPDUs
+    dBm_u m_requestedRssiSta2; ///< requested RSSI from STA 2 at AP for HE TB PPDUs
 
-    double m_rssiSta1; ///< expected RSSI (in dBm) from STA 1 at AP for HE TB PPDUs
-    double m_rssiSta2; ///< expected RSSI (in dBm) from STA 2 at AP for HE TB PPDUs
+    dBm_u m_rssiSta1; ///< expected RSSI from STA 1 at AP for HE TB PPDUs
+    dBm_u m_rssiSta2; ///< expected RSSI from STA 2 at AP for HE TB PPDUs
 
-    double m_tol; ///< tolerance (in dB) between received and expected RSSIs
+    dB_u m_tol; ///< tolerance between received and expected RSSIs
 };
 
 TestUlOfdmaPowerControl::TestUlOfdmaPowerControl()
@@ -5451,7 +5447,7 @@
     muBar.SetMoreTF(true);
     muBar.SetCsRequired(true);
     muBar.SetUlBandwidth(DEFAULT_CHANNEL_WIDTH);
-    muBar.SetGiAndLtfType(1600, 2);
+    muBar.SetGiAndLtfType(NanoSeconds(1600), 2);
     muBar.SetApTxPower(static_cast<int8_t>(m_txPowerAp));
     muBar.SetUlSpatialReuse(60500);
 
@@ -5490,33 +5486,33 @@
         ++index;
     }
 
-    WifiTxVector tbTxVector = muBar.GetHeTbTxVector(staIds.front());
+    WifiTxVector tbTxVector{muBar.GetHeTbTxVector(staIds.front())};
     muBar.SetUlLength(HePhy::ConvertHeTbPpduDurationToLSigLength(MicroSeconds(128),
                                                                  tbTxVector,
                                                                  WIFI_PHY_BAND_5GHZ)
                           .first);
 
     WifiConstPsduMap psdus;
-    WifiTxVector txVector = WifiTxVector(HePhy::GetHeMcs7(),
-                                         0,
-                                         WIFI_PREAMBLE_HE_SU,
-                                         800,
-                                         1,
-                                         1,
-                                         0,
-                                         DEFAULT_CHANNEL_WIDTH,
-                                         false,
-                                         false,
-                                         false,
-                                         m_bssColor);
+    WifiTxVector txVector{HePhy::GetHeMcs7(),
+                          0,
+                          WIFI_PREAMBLE_HE_SU,
+                          NanoSeconds(800),
+                          1,
+                          1,
+                          0,
+                          DEFAULT_CHANNEL_WIDTH,
+                          false,
+                          false,
+                          false,
+                          m_bssColor};
 
-    Ptr<Packet> bar = Create<Packet>();
+    auto bar = Create<Packet>();
     bar->AddHeader(muBar);
 
-    Mac48Address receiver = Mac48Address::GetBroadcast();
+    auto receiver = Mac48Address::GetBroadcast();
     if (staIds.size() == 1)
     {
-        uint16_t aidSta1 = DynamicCast<StaWifiMac>(m_sta1Dev->GetMac())->GetAssociationId();
+        const auto aidSta1 = DynamicCast<StaWifiMac>(m_sta1Dev->GetMac())->GetAssociationId();
         if (staIds.front() == aidSta1)
         {
             receiver = Mac48Address::ConvertFrom(m_sta1Dev->GetAddress());
@@ -5538,10 +5534,10 @@
     hdr.SetDsFrom();
     hdr.SetNoRetry();
     hdr.SetNoMoreFragments();
-    Ptr<WifiPsdu> psdu = Create<WifiPsdu>(bar, hdr);
+    auto psdu = Create<WifiPsdu>(bar, hdr);
 
-    Time nav = m_apDev->GetPhy()->GetSifs();
-    uint16_t staId = staIds.front(); // either will do
+    auto nav = m_apDev->GetPhy()->GetSifs();
+    const auto staId = staIds.front(); // either will do
     nav += m_phyAp->CalculateTxDuration(GetBlockAckSize(BlockAckType::COMPRESSED),
                                         tbTxVector,
                                         DEFAULT_WIFI_BAND,
@@ -5559,9 +5555,9 @@
                                                std::vector<bool> /*statusPerMpdu*/)
 {
     NS_TEST_ASSERT_MSG_EQ(txVector.GetPreambleType(), WIFI_PREAMBLE_HE_TB, "HE TB PPDU expected");
-    double rssi = rxSignalInfo.rssi;
+    const auto rssi = rxSignalInfo.rssi;
     NS_ASSERT(psdu->GetNMpdus() == 1);
-    WifiMacHeader hdr = psdu->GetHeader(0);
+    const auto& hdr = psdu->GetHeader(0);
     NS_TEST_ASSERT_MSG_EQ(hdr.GetType(), WIFI_MAC_CTL_BACKRESP, "Block ACK expected");
     if (hdr.GetAddr2() == m_sta1Dev->GetAddress())
     {
@@ -5598,15 +5594,14 @@
 void
 TestUlOfdmaPowerControl::DoSetup()
 {
-    Ptr<Node> apNode = CreateObject<Node>();
+    auto apNode = CreateObject<Node>();
     NodeContainer staNodes;
     staNodes.Create(2);
 
-    Ptr<MultiModelSpectrumChannel> spectrumChannel = CreateObject<MultiModelSpectrumChannel>();
-    Ptr<MatrixPropagationLossModel> lossModel = CreateObject<MatrixPropagationLossModel>();
+    auto spectrumChannel = CreateObject<MultiModelSpectrumChannel>();
+    auto lossModel = CreateObject<MatrixPropagationLossModel>();
     spectrumChannel->AddPropagationLossModel(lossModel);
-    Ptr<ConstantSpeedPropagationDelayModel> delayModel =
-        CreateObject<ConstantSpeedPropagationDelayModel>();
+    auto delayModel = CreateObject<ConstantSpeedPropagationDelayModel>();
     spectrumChannel->SetPropagationDelayModel(delayModel);
 
     SpectrumWifiPhyHelper spectrumPhy;
@@ -5624,8 +5619,8 @@
 
     WifiMacHelper mac;
     mac.SetType("ns3::StaWifiMac");
-    NetDeviceContainer staDevs = wifi.Install(spectrumPhy, mac, staNodes);
-    wifi.AssignStreams(staDevs, 0);
+    auto staDevs = wifi.Install(spectrumPhy, mac, staNodes);
+    WifiHelper::AssignStreams(staDevs, 0);
     m_sta1Dev = DynamicCast<WifiNetDevice>(staDevs.Get(0));
     NS_ASSERT(m_sta1Dev);
     m_sta2Dev = DynamicCast<WifiNetDevice>(staDevs.Get(1));
@@ -5649,7 +5644,7 @@
 
     MobilityHelper mobility;
     mobility.SetMobilityModel("ns3::ConstantPositionMobilityModel");
-    Ptr<ListPositionAllocator> positionAlloc = CreateObject<ListPositionAllocator>();
+    auto positionAlloc = CreateObject<ListPositionAllocator>();
     positionAlloc->Add(Vector(0.0, 0.0, 0.0));
     positionAlloc->Add(Vector(1.0, 0.0, 0.0)); // put close enough in order to use MCS
     positionAlloc->Add(
@@ -5686,8 +5681,8 @@
     RngSeedManager::SetRun(1);
     int64_t streamNumber = 0;
 
-    Ptr<WifiPhy> phySta1 = m_sta1Dev->GetPhy();
-    Ptr<WifiPhy> phySta2 = m_sta2Dev->GetPhy();
+    auto phySta1 = m_sta1Dev->GetPhy();
+    auto phySta2 = m_sta2Dev->GetPhy();
 
     m_phyAp->AssignStreams(streamNumber);
     phySta1->AssignStreams(streamNumber);
@@ -5705,7 +5700,7 @@
     phySta2->SetAttribute("TxPowerEnd", DoubleValue(m_txPowerEnd));
     phySta2->SetAttribute("TxPowerLevels", UintegerValue(m_txPowerLevels));
 
-    Time relativeStart = MilliSeconds(0);
+    Time relativeStart{};
     if (setupBa)
     {
         // Set up BA for each station once the association phase has ended
@@ -5722,7 +5717,7 @@
     }
     else
     {
-        Ptr<ApWifiMac> apMac = DynamicCast<ApWifiMac>(m_apDev->GetMac());
+        auto apMac = DynamicCast<ApWifiMac>(m_apDev->GetMac());
         NS_ASSERT(apMac);
         apMac->SetAttribute("BeaconGeneration", BooleanValue(false));
     }
